SystemOrganization addCategory: #KEGGeneratorPost001FakeNew!

!KEGAbstractGenerator class methodsFor: '*keggeneratorpost001fakenew' stamp: 'KjellGodo 2/3/2013 21:36'!
abstractGeneratorClass 

        "Method Version: keg1.  "
        "Copyright Kjell E God April 13, 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today April 13, 1999 "

	"Return the AbstractGenerator Class for self."

	"| answer |

				MT b:#abstractGeneratorClass s:self .

	answer := self .

				MT e:#abstractGeneratorClass s:self .

	^answer ."
	"Return the AbstractGenerator Class for self.

	(| source-:( self( this method ) is supposed to come from the-:(
		C:\Kris\Kjell\Smalltalk\Dolphin\Images\InUse\KEGFakeGeneratorMethods.st
	) file. ) )-source

	" ! !

!KEGAbstractGenerator methodsFor: '*keggeneratorpost001fakenew' stamp: 'KjellGodo 2/3/2013 11:31'!
generators

	"Method Version: keg2.  "
	" Copyright Kjell E God 20020507"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20020803, 20020507"
	| "answer" notLastYet next |
							"MT b:#generators s:self."
	"answer :="
	^KEGAbstractGenerator new 
		firstBlock:[ notLastYet := true . next := self ]
		nextBlock:[ 
			notLastYet ifTrue:[
				( ( next := next generator )
					ifNil:[ true ]
					ifNotNil:[ :n | n isOnAStream ]
				)ifTrue:[ notLastYet := false ] . "<---( causes the next return from ( answer next ) to be nil.  Which causes all future returns from ( answer next ) to be nil until the answer is reset via ( answer reset ). )"
				next
			]
		] .
							"MT e:#generators s:self."
	"^answer ."
	"Return a sequence of <self h1 h2 h3 h4 ... hL> where h1 is the Generator that
	feeds into self and h2 is the Generator that feeds into h1 and h3 is the Generator
	that feeds into h2 etc where hL is the last headwaters Generator and is often on
	a Stream.  The hi are call headwaters Generators because each h(i) feeds into
	h(i-1) like a creek where each pond in the creek feeds into the next pond.
	(|KEG2-<D:20020802>-: added the ifNil:ifNotNil: so that Generators that are
	not based on a Stream don't blow up.  Example-: FileStream>>asGenerator . )

	(| source-:( self( this method ) is supposed to come from the-:(
		C:\Kris\Kjell\Smalltalk\Dolphin\Images\InUse\KEGFakeGeneratorMethods.st
	) file. ) )-source

	" ! !

!KEGAbstractGenerator methodsFor: '*keggeneratorpost001fakenew' stamp: 'KjellGodo 4/7/2013 15:32'!
headWaters

	"Method Version: keg2.  "
	" Copyright Kjell E God 20020507"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20020803, 20020507"
	"<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 2 >>"
							"MT b:#headWaters s:self."

	( headWaters ifNil:[ 
		( headWaters := WeakArray new:( 1 ) ).
		( ( self isOnAStream ) or:[ self generator isNil ] )
			ifTrue:[ headWaters at:1put: self ] "<---[ Could cause memory leak if we don't use WeakArray ]"
			ifFalse:[ headWaters at:1put:( self generators last ) ]
	] ).
							"MT e:#headWaters s:self."
	^headWaters at:1 .
	"Go up the list of head waters Generators that feed into self until we get to the
	very last headWaters of self which is assumed to be on a Stream.
	Return the very last headWaters Generator.  For an example of the usage of self(
	this method ) please see-:( 
		KEGAbstractGenerator>>on: 
		KEGStringGenerator>>lineWords
		PositionableStream>>superSubStrings
		KEGTransaction>>between:and:
		KEGNetscape4ETradeStockTrade>>fromString:
	)-see
	(|KEG2-<D:20020803>-:
			 	Changed-:( '( self isOnAStream )' )
				to-:( '( ( self isOnAStream ) or:[ self generator isNil ] )' )
		so that the case where a Generator is not based on a Stream ( in the generator
		instance variable ) will not blow up.  Example-: FileStream>>asGenerator . )

	( [_]: Rebuild self( this comment ) since it got accidentally deleted this morning.
		<D:20020508> )

	(| source-:( self( this method ) is supposed to come from the-:(
		C:\Kris\Kjell\Smalltalk\Dolphin\Images\InUse\KEGFakeGeneratorMethods.st
	) file. ) )-source

	" "

	#(  ) asGenerator ifNotNil:[ :g | ( g collect:[ :x | x ] ) headWaters == g ]

	#(  ) asGenerator ifNotNil:[ :g | (( g collect:[ :x | x ] ) collect:[ :x | x ] ) headWaters == g ]

	#(  ) asGenerator ifNotNil:[ :g | ((( g collect:[ :x | x ] ) collect:[ :x | x ] ) collect:[ :x | x ] ) headWaters == g ]

	"! !

!KEGAbstractGenerator methodsFor: '*keggeneratorpost001fakenew' stamp: 'KjellGodo 2/3/2013 21:34'!
on: aCollection

	"Method Version: keg1.  "
	" Copyright Kjell E God 20020507"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20020507"
	| answer |
							"MT b:#on: s:self."
	"answer :=" 
	^( ( answer := self headWaters ) isOnAStream )
		ifTrue:[ 
			( answer == self )
				ifTrue:[ super on: aCollection ]
				ifFalse:[ answer on: aCollection ]
		] .
							"MT e:#on: s:self."
	"^answer ."
	"Go up the list of head waters Generators that feed into self until we get to the
	very last headWaters of self which is assumed to be on a Stream.  And then make
	the Stream be on aCollection and reinitialize the Stream to fit the new Collection.
	Return the very last headWaters Generator in the case aCollection was inserted
	into the headWaters Generator or nil otherwise( In which case the caller can call
	self>>headWaters to find out what the heck is going on with it. ).

	" ! !

!KEGAbstractGenerator methodsFor: '*keggeneratorpost001fakenew' stamp: 'KjellGodo 2/3/2013 21:33'!
"(| defineMethod-:(" onGenerator: aGenerator ")
	notes-:(		Method Version: keg2.
				 Copyright Kjell E God 20051230
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20130203 21:08 ) 20051230
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#onGenerator: s:self )."
	^(	
		generator
			ifNil:[ self error: 'No KEGGenerator to connect to at end of Generator list' ] "<---[ See note below ]"
			ifNotNil:[ :g | g onGenerator: aGenerator ]

	)"return:( 					MT e:#onGenerator: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Make the headwaters of self be aGenerator.
	aGenerator can be a Stream( see below ).

 )-summary
 methodDescriptionDetail-:(

	Go up the list of head waters Generators that feed into self 
	until we get to the very last headWaters G of self which is assumed
	to be of the KEGGenerator Class so that the >>generator: message
	above will work and then the G>>reset and G>>next messages will
	be redirected to aGenerator.  And then 
	replace the generator in G
	with aGenerator.  aGenerator can be anything that responds
	to both the >>reset and the >>next messages including
	Streams.
	Return aGenerator.

	This is how you can build up two Generators and then combine them
	later.  If A produces Generator GA and B produces Generator GB then
	GB onGenerator: GA
	is equivalent to
	( A B ) which is A followed by B so to speak, sort of. A creates GA and
	then B adds on to GA.  See the test cases below.

	You only have to create a Generator once and then you can reuse it
	in different ways by sticking another Generator onto it.

	But if you do ( GB onGenerator: GA ).( GB onGenerator: GC )
	you get ( C B ).  But with the alternate code below you would
	get ( C A B ) because the headWaters searches for the KEGGenerator
	on a Stream and there might not be one or it might be at the end of
	the list of Generators ( A B ).

	REMEMBER ( self headWaters ) cannot be a KEGAbstractGenerator
	because the 
	KEGAbstractGenerator>>reset and
	KEGAbstractGenerator>>next
	do not know about the generator instance variable( and won't for speed ).

	It is easy to get a new generic empty KEGGenerator by doing

	( KEGGenerator streamGenerator )

	that can be used for various things and as a base for making new
	Generators that can be reused using the
	KEGAbstractGenerator>>onGenerator: and
	KEGAbstractGenerator>>on: messages.

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( 20130203 ) madeChanges-:( cut the alternate code below out and added code above and
		created KEGGenerator>>onGenerator: to stop the Generator list traversal easily )-madechanges )-chg )-keg2
 )-changes
 testCases-:(

	#(  ) asGenerator ifNotNil:[ :g | (( g collect:[ :x | x + 1 ] ) onGenerator:( #(  ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #(  ) ]

	#(  ) asGenerator ifNotNil:[ :g | (( g collect:[ :x | x + 1 ] ) onGenerator:( #( 1 ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #( 3 ) ]

	#(  ) asGenerator ifNotNil:[ :g | (( g collect:[ :x | x + 1 ] ) onGenerator:( #( 1 2 3 ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #( 3 4 5 ) ]

	#(  ) asGenerator ifNotNil:[ :g | ((( g collect:[ :x | x ] ) collect:[ :x | x + 1 ] ) onGenerator:( #( 1 2 3 ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #( 3 4 5 ) ]

	#(  ) asGenerator ifNotNil:[ :g | (((( g collect:[ :x | x ] ) collect:[ :x | x ] ) collect:[ :x | x + 1 ] ) onGenerator:( #(  ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #(  ) ]

	KEGGenerator streamGenerator ifNotNil:[ :g | (((( g collect:[ :x | x ] ) collect:[ :x | x ] ) collect:[ :x | x + 1 ] ) onGenerator:( #( 1 2 3 ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #( 3 4 5 ) ]

	#(  ) asGenerator ifNotNil:[ :g | (((( g collect:[ :x | x ] ) collect:[ :x | x ] ) collect:[ :x | x + 1 ] ) onGenerator:( #( 1 2 3 ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asOrderedCollection asArray = #( 3 4 5 ) ]

	(( #(  ) asGen collect:[ :x | x ] ) onGenerator:( #( 1 2 3 ) asGen collect:[ :x | x - 1 ] ) ; onGenerator:( #( 1 2 3 ) asGen collect:[ :x | x + 1 ] ) ; yourself ) asArray = #( 2 3 4 )

	(( #(  ) asGen collect:[ :x | x ] ) onGenerator:( #( 1 2 3 ) readStream ) ; yourself ) asArray = #( 1 2 3 )

 )-testCases
 alternateCode-:(

		( self headWaters ) generator:( aGenerator )

 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGenerator class methodsFor: '*keggeneratorpost001fakenew' stamp: 'KjellGodo 4/7/2013 15:23'!
abstractGeneratorClass 

        "Method Version: keg1.  "
        "Copyright Kjell E God April 13, 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today April 13, 1999 "
	"<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 1 >>"
	"| answer |"
				"MT b:#abstractGeneratorClass s:self ."

	"answer :=" ^KEGAbstractGenerator .

				"MT e:#abstractGeneratorClass s:self ."

	"^answer ."
	"Return the AbstractGenerator Class for self.

	(| source-:( self( this method ) is supposed to come from the-:(
		C:\Kris\Kjell\Smalltalk\Dolphin\Images\InUse\KEGFakeGeneratorMethods.st
	) file. ) )-source

	" ! !

!KEGGenerator class methodsFor: '*keggeneratorpost001fakenew' stamp: 'KjellGodo 2/3/2013 21:44'!
"(| defineMethod-:(" abstractGeneratorOn: aGenerator ")
	notes-:(		Method Version: keg3.
				 Copyright Kjell E God Jan  3, 1994
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20020507, July 24 1999, Jan  3, 1994
	<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 1 >>
	)-notes methodBody-:(
 (| let-:("| rTGRN |")
    letBody-:("					"( MT b:#abstractGeneratorOn: s:self )."

	^(
		( KEGFakeGeneratorClass new:( 
			( ReuseThisGeneratorRightNow
				ifNil:[ self abstractGeneratorClass new ]
				ifNotNil:[
					( rTGRN := ReuseThisGeneratorRightNow ).
					( ReuseThisGeneratorRightNow := nil ).
					( rTGRN ) ]
			) generator: aGenerator ; "<---( points to the headwaters Generators upstream )"
			  yourself
		))

	)"return:( 					MT e:#abstractGeneratorOn: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Private - Return the Class of AbstractGenerator that is to be used in all
	Generator methods that create AbstractGenerators.  ReSend it to 
	abstractGeneratorClass which seems to be what is being used in Dolphin and
	the newer stuff.

 )-summary
 methodDescriptionDetail-:(
	
	(| originalSource-:( self( this method ) is supposed to come from the-:(
		SessionManager current imageBase , 'KEGFakeGeneratorMethods.st'
	) file. ) )-source

 )-detail
 todos-:(

	( [_]:[]: In future after self( this change ) is older you could comment out the MT
	debugging and answer local variable as a slight speed optimization.  Also you
	could make a new instance variable for self called-:( headWaters ) which when it
	was set to nonNil would cause the KEGFakeGeneratorClass stuff above to be
	activated whereAs the default would be not to use it as a slight speed
	optimization.  But as for us, as of now we are going to embrace
	all the headwinds that we may hit us right smack in the face and so go we with
	this upstart change full force.  If we get too much flack we may have to
	implement headWaters as a way of cutting down on the flack until we get it
	figured out more.  Since self( this method ) is called during every single
	AbstractGenerator creation out there we may be in for
	a lot of flack( bugs ).  But here we go anyway.  =>Accept<= . )

 )-todos
 changes-:(
	(| KEG3-: ( Changes onDate-:( 20020507 ) madeChanges-:( 
		Added the KEGFakeGeneratorClass stuff.  self( this method ) used to
		be just-:(
			^self abstractGeneratorClass
		) but now we wrap the new Generator in a KEGFakeGeneratorClass so that when
		it gets the >>new method it will just return the new AbstractGenerator inside of
		it.  See the
		KEGFakeGeneratorClass and the KEGFakeGeneratorPackage.st file and the
		KEGAbstractGenerator>>on: and KEGAbstractGenerator>>generator and
		KEGAbstractGenerator>>isOnAStream methods.
	)-madeChanges )
	)-keg3
 )-changes
 testCases-:(
	testCases
 )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGenerator methodsFor: '*keggeneratorpost001fakenew' stamp: 'KjellGodo 2/3/2013 21:45'!
abstractGenerator

        "Method Version: keg5.  "
	" Copyright Kjell E God Jan  3, 1994"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint ( 20110701 16:32 ) 20020508, 20020507, July 24 1999, Jan  3, 1994"
	| answer |
								"MT b:#abstractGenerator s:self ."
	"self halt ."
	( answer := 
			(
			( 
			( self isOnAStream 
			)	ifTrue:[ self ]
				ifFalse:[ generator ifNil:[ self ] ]
			) class 
			) abstractGeneratorOn: self
			).

								"MT e:#abstractGenerator s:self ."
	^answer

	"Private - See the method comments in abstractGeneratorOn: .

	KEG5-:( Added the generator part so spawned Generators will take after the
		generator self is on if there is one.  If the generator is on a Stream
		that could cause problems.  Not anymore.  The idea is that the subClasses SC
		of KEGGenerator that are not KEGAbstractGenerator will probably be on
		a KEGAbstractGenerator AG and so we want any Generators spawned
		off of one of these SCs to take mostly after the AG inside of it.  So a
		KEGSimpleCanBackup SCB would mostly take after the AG that it is on and so
		any Generator spawned from SCB would be an AG that SCB is on. )

	KEG4-:( Moved the guts of self( this method ) into >>abstractGeneratorOn:
	This is being done to fix the KEGGenerator>>asStringGenerator and other such
	related methods. )

	(| source-:( self( this method ) is supposed to come from the-:(
		C:\Kris\Kjell\Smalltalk\Dolphin\Images\InUse\KEGFakeGeneratorMethods.st
	) file. ) )-source

	"  ! !

!KEGGenerator methodsFor: '*keggeneratorpost001fakenew' stamp: 'KjellGodo 2/3/2013 21:33'!
"(| defineMethod-:(" onGenerator: aGenerator ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20130203
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20130203 20:58 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#onGenerator: s:self )."
	^(	
		( self generator: aGenerator )

	)"return:( 					MT e:#onGenerator: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Make the headwaters of self be aGenerator.
	aGenerator can be a Stream( see below ).

 )-summary
 methodDescriptionDetail-:(

	See the KEGAbstractGenerator>>onGenerator: for more details.

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 alternateCode-:(
	alternateCode
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGenerator methodsFor: '*keggeneratorpost001fakenew' stamp: 'KjellGodo 4/13/2013 16:38'!
"(| defineMethod-:(" reUseVia: convertingBlk ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20021002
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20021002
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#reUseVia: s:self )."

	( ReuseThisGeneratorRightNow := self ).
	^(
		( convertingBlk value )

	)"return:( 					MT e:#reUseVia: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Assign self to ReuseThisGeneratorRightNow so that the 
	KEGGenerator class>>abstractGeneratorOn: method will use self as the new
	Generator in the next converting message instead of creating a new one.
	( Where converting messages are those in the ''converting'' category in the
	ClassHierarchyBrowsers like-:( collect: select: reject: etc ) )

 )-summary
 methodDescriptionDetail-:(

	convertingBlk should be a niladicValuable and it should have a Generator
	converting message in it like for example-:(
		( aGen1 reUseVia:[ ( newGen := aGen2 collect:[ ... ] ).	... ] )
		or
		( aGen1 reUseVia:[ ( newGen := aGen2 select:[ ... ] ).		... ] )
		or
		( aGen1 reUseVia:[ ( newGen := aGen2 reject:[ ... ] ).		... ] )
		or
		( aGen1 reUseVia:[ ( newGen := aGen2 detect:[ ... ] ).		... ] )
		or
		( aGen1 reUseVia:[ ( newGen := aGen2 etc:[ ... ] ).		... ] )
	)-forexample .  newGen will have aGen1 inside of it hopefully reused in
	the right way. The converting message-:( collect: select: reject: etc ) should
	be near enough to the beginning of the convertingBlk so that no other
	Generator converting messages besides the ones present in the convertingBlk
	can cause the KEGGenerator class>>abstractGeneratorOn: to execute
	and so cause aGen1 above to be reused in some Generator that you hadn't
	intended.  But, on the other hand, what does it matter.  aGen1 got reused.
	Just not in the Generator you intended it for.  The main goal that it get
	reUsed has still been satisfied.  Although it might make you scratch your
	head during debugging some.

 )-detail
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG3-: ( Changes onDate-:( ... ) theOldCode-:( ... ) wasReplacedBy-:( ... ) )-chg )-keg3
	(| KEG2-: ( Changes onDate-:( ... ) theOldCode-:( ... ) wasReplacedBy-:( ... ) )-chg )-keg2
	(| KEG1-: ( Changes onDate-:( ... ) theOldCode-:( ... ) wasReplacedBy-:( ... ) )-chg )-keg1
 )-changes
 testCases-:(
	testCases
 )-testCases
 rants-:(
	
	( This has always been the last bit of Generator related memory allocation
	that I could never get rid of for 10 years.  But now it is done and quite
	minimally it looks like.  And so, I am left hitting myself in the forehead
	and going ''WHY DIDN'T i THINK OF THAT?'' .  It looks like this one
	simple little method will revolutionize the ability to get Generators to
	minimize inLoop memory allocations.  And that is satisfying mentally if
	not actually.  But, it sure took it's time getting here.  And I can remember
	puzzling and puzzling over getting rid of new Generator creations in a dozen
	different applications.  But I guess that perhaps was the problem.  It was
	always
	in the midst of an application.  And there was never enough of a link to the
	present idea to get any traction.  Oh well.  I have been waiting for this for
	so long.  10 years.  And now here it is.  So simple.  An instantaneous blink
	in in the midst of something else.  But then turning back.  And going back
	to see this little thing.  One sees that this little blip is perhaps worth a
	hundred new shuffle converting methods.  And now of all times it just pops
	up out of the middle of nowhere.  Where have you been for so long?  I ask
	it.  But alls I get is a shrug. )

 )-rants )-defineMethod"! !

Object subclass: #KEGFakeGeneratorClass
	instanceVariableNames: 'generator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KEGGeneratorPost001FakeNew'!

!KEGFakeGeneratorClass commentStamp: 'KjellGodo 2/3/2013 11:20' prior: 0!
KEGFakeGeneratorClass provides a way whereby AbstractGenerators
	can be linked up in a chain so that all headwaters Generators are always
	accessible to Generators more downstream 
	to the KEG Smalltalk software & software codes.
	Copyright  2002 Kjell E God

	This Package is licensed under the MIT license.  Please evaluate ( Object licenseMIT )
	for more information about the MIT license.  Or see KEGLicense class>>licenseMIT .


<D:20020507>=:

self( this Class ) is a kludge so that the KEGGenerator Class won't have to be changed in a drastic way to get the proposed functionality.

Instance Variables:
	generator 			Looks like the KEGGenerator instance variable of the 
						same name but it is used to create a new KEGAbstractGenerator
						of the correct Class and linked up to the other 
						KEGAbstractGenerators in the correct way.!

!KEGFakeGeneratorClass class methodsFor: 'instance creation' stamp: 'KjellGodo 2/3/2013 11:21'!
new: aKEGAbstractGenerator

	"Method Version: keg1.  "
	" Copyright Kjell E God 20020507"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20020507"
	"| answer |"
							"MT b:#new: s:self."

	^( "answer :=" self new ) generator: aKEGAbstractGenerator ; yourself .

							"MT e:#new: s:self."
	"^answer ."
	"Create a new instance of self and put aKEGAbstractGenerator into it
	ready to be returned into one of the KEGGenerator conversion methods
	( like >>collect: select: reject: etc ) via the >>new message."! !

!KEGFakeGeneratorClass methodsFor: 'accessing' stamp: 'KjellGodo 2/3/2013 11:23'!
generator: aKEGAbstractGenerator

	"Method Version: keg1.  "
	" Copyright Kjell E God 20020507"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20020507"
	"| answer |"
							"MT b:#generator: s:self."

	"answer :=" ^generator := aKEGAbstractGenerator .

							"MT e:#generator: s:self."
	"^answer ."
	"Set the value of the class instance variable which is to contain a KEGAbstractGenerator
	for passing to the various KEGGenerator conversion methods via the >>new method.
	When self this Class is older and stable then you can comment out the MT debugging
	and answer stuff.  aKEGAbstractGenerator should be chained up to its headwaters
	Generators( that feed into it ) via its .generator instance variable."! !

!KEGFakeGeneratorClass methodsFor: 'accessing' stamp: 'KjellGodo 2/3/2013 11:24'!
new

	"Method Version: keg1.  "
	" Copyright Kjell E God 20020507"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20020507"
	"| answer |"
							"MT b:#new s:self."

	"answer :=" ^generator . "<---( A KEGAbstractGenerator. )"

							"MT e:#new s:self."
	"^answer ."
	"self( this method ) is meant to be called by the KEGGenerator conversion methods
	like collect: select: reject: detect: etc."! !
